#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon;
use MyGraphs;


my $max_level = 4;
if (@ARGV) { $max_level = shift @ARGV; }

print "% generated by tools/$FindBin::Script $max_level\n";

my $var = 'gen';

my %arrays;
foreach my $k (0 .. $max_level) {
  my $graph = MyR5Dragon::r5join_area_tree_Graph($k);

  my @degrees = (0,0,0,0,0);
  foreach my $v ($graph->vertices) {
    $degrees[$graph->vertex_degree($v)]++;
  }
  push @{$arrays{'JADegCount0'}}, $degrees[0];
  push @{$arrays{'JADegCount1'}}, $degrees[1];
  push @{$arrays{'JADegCount2'}}, $degrees[2];
  push @{$arrays{'JADegCount4'}}, $degrees[4];
}

foreach my $name ('JADegCount0','JADegCount1','JADegCount2','JADegCount4',
                 ) {
  my $aref = $arrays{$name};
  print "% GP-DEFINE  ${var}_${name}_samples = [", join(',',@$aref),"];\n";
}

print "% end generated\n";
exit 0;
