#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::PlanePath::R5DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon ':all';
use MyPrintwrap ':all';


my $level = 2;
print "  % generated by tools/$FindBin::Script\n";
print "  \\newcommand{\\MyLevel}{$level}\n";

my $path = Math::PlanePath::R5DragonCurve->new;
my ($n_lo, $n_hi) = $path->level_to_n_range($level);

my %seen;
my $P = 0;
{
  my ($x,$y) = $path->n_to_xy($n_lo);
  print "  \\node (start) at ($x,$y) [my dot];\n";
  $seen{"$x,$y"}++;
  $P++;
}
{
  my ($x,$y) = $path->n_to_xy($n_hi);
  print "  \\node (end) at ($x,$y) [my dot];\n";
  $seen{"$x,$y"}++;
  $P++;
}

$Printwrap = 2;
printwrap("\\path foreach \\p in {");
$Printwrap += 2;
foreach my $n ($n_lo .. $n_hi) {
  my ($x,$y) = $path->n_to_xy($n);
  next if $seen{"$x,$y"}++;
  printwrap("($x,$y),");
  $P++;
}
printwrap("}");
printwrap("{ \\p node[my dot] };\n");

print "  \\newcommand{\\MyP}{$P}\n";
print "% GP-Test-Last  P($level)==$P\n";

print "  % end generated\n";
exit 0;
